## ros-eloquent-rcl-action 0.8.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rcl_action)

find_package(ament_cmake_ros REQUIRED)

find_package(rosidl_generator_c REQUIRED)
find_package(action_msgs REQUIRED)
find_package(rcl REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw REQUIRED)

include_directories(
  include
  ${action_msgs_INCLUDE_DIRS}
  ${rcl_INCLUDE_DIRS}
)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

set(rcl_action_sources
  src/${PROJECT_NAME}/action_client.c
  src/${PROJECT_NAME}/action_server.c
  src/${PROJECT_NAME}/goal_handle.c
  src/${PROJECT_NAME}/goal_state_machine.c
  src/${PROJECT_NAME}/graph.c
  src/${PROJECT_NAME}/names.c
  src/${PROJECT_NAME}/types.c
)

set_source_files_properties(
  ${rcl_action_sources}
  PROPERTIES language "C"
)

add_library(${PROJECT_NAME}
  ${rcl_action_sources}
)

ament_target_dependencies(${PROJECT_NAME}
  "action_msgs"
  "rcl"
  "rcutils"
  "rmw"
  "rosidl_generator_c"
)

rcl_set_symbol_visibility_hidden(${PROJECT_NAME} LANGUAGE "C")
# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME} PRIVATE "RCL_ACTION_BUILDING_DLL")

install(
  DIRECTORY include/
  DESTINATION include
)

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  find_package(osrf_testing_tools_cpp REQUIRED)
  find_package(test_msgs REQUIRED)
  ament_lint_auto_find_test_dependencies()
  ament_find_gtest()
  # Gtests
  ament_add_gtest(test_action_client
    test/rcl_action/test_action_client.cpp
  )
  if(TARGET test_action_client)
    target_include_directories(test_action_client PUBLIC
      include
    )
    target_link_libraries(test_action_client
      ${PROJECT_NAME}
    )
    ament_target_dependencies(test_action_client
      "osrf_testing_tools_cpp"
      "rcl"
      "test_msgs"
    )
  endif()

  # get the rmw implementations ahead of time
  find_package(rmw_implementation_cmake REQUIRED)
  get_available_rmw_implementations(rmw_implementations)
  foreach(rmw_implementation ${rmw_implementations})
    find_package("${rmw_implementation}" REQUIRED)
  endforeach()

  function(custom_test_c target)
    ament_add_gtest(
      "${target}${target_suffix}" ${ARGN}
      TIMEOUT 60
      ENV
      RCL_ASSERT_RMW_ID_MATCHES=${rmw_implementation}
      RMW_IMPLEMENTATION=${rmw_implementation}
    )
    if(TARGET ${target}${target_suffix})
      target_compile_definitions(${target}${target_suffix}
        PUBLIC "RMW_IMPLEMENTATION=${rmw_implementation}")
      target_include_directories(${target}${target_suffix} PUBLIC
        include
      )
      target_link_libraries(${target}${target_suffix}
        ${PROJECT_NAME}
      )
      ament_target_dependencies(${target}${target_suffix}
        "osrf_testing_tools_cpp"
        "rcl"
        "test_msgs"
      )
    endif()
  endfunction()

  macro(targets)
    custom_test_c(test_action_communication
      "test/rcl_action/test_action_communication.cpp")
    custom_test_c(test_action_interaction
      "test/rcl_action/test_action_interaction.cpp")

    custom_test_c(test_graph
      "test/rcl_action/test_graph.cpp")
  endmacro()

  call_for_each_rmw_implementation(targets)

  ament_add_gtest(test_action_server
    test/rcl_action/test_action_server.cpp
  )
  if(TARGET test_action_server)
    target_include_directories(test_action_server PUBLIC
      include
    )
    target_link_libraries(test_action_server
      ${PROJECT_NAME}
    )
    ament_target_dependencies(test_action_server
      "osrf_testing_tools_cpp"
      "rcl"
      "test_msgs"
    )
  endif()
  ament_add_gtest(test_goal_handle
    test/rcl_action/test_goal_handle.cpp
  )
  if(TARGET test_goal_handle)
    target_include_directories(test_goal_handle PUBLIC
      include
    )
    target_link_libraries(test_goal_handle
      ${PROJECT_NAME}
    )
    ament_target_dependencies(test_action_server "rcl")
  endif()
  ament_add_gtest(test_goal_state_machine
    test/rcl_action/test_goal_state_machine.cpp
  )
  if(TARGET test_goal_state_machine)
    target_link_libraries(test_goal_state_machine
      ${PROJECT_NAME}
    )
    ament_target_dependencies(test_action_server "rcl")
  endif()
  ament_add_gtest(test_types
    test/rcl_action/test_types.cpp
  )
  if(TARGET test_types)
    target_include_directories(test_types PUBLIC
      include
    )
    target_link_libraries(test_types
      ${PROJECT_NAME}
    )
    ament_target_dependencies(test_action_server "rcl")
  endif()
  ament_add_gtest(test_names
    test/rcl_action/test_names.cpp
  )
  if(TARGET test_names)
    target_link_libraries(test_names
      ${PROJECT_NAME}
    )
    ament_target_dependencies(test_action_server "rcl")
  endif()
endif()

# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_dependencies(ament_cmake)
ament_export_dependencies(rcl)
ament_export_dependencies(rcutils)
ament_export_dependencies(rmw)
ament_export_dependencies(action_msgs)
ament_export_dependencies(rosidl_generator_c)
ament_package()

=== debian/changelog ===
ros-eloquent-rcl-action (0.8.5-1bionic) bionic; urgency=high



 -- Jacob Perron <jacob@openrobotics.org>  Fri, 04 Dec 2020 06:00:00 -0000

ros-eloquent-rcl-action (0.8.4-1bionic) bionic; urgency=high



 -- Jacob Perron <jacob@openrobotics.org>  Fri, 17 Jan 2020 06:00:00 -0000

ros-eloquent-rcl-action (0.8.3-1bionic) bionic; urgency=high



 -- Jacob Perron <jacob@openrobotics.org>  Fri, 08 Nov 2019 06:00:00 -0000

ros-eloquent-rcl-action (0.8.2-1bionic) bionic; urgency=high

  * Correct action server documentation (#519 <https://github.com/ros2/rcl/issues/519>)
  * Add mechanism to pass rmw impl specific payloads during pub/sub creation (#513 <https://github.com/ros2/rcl/issues/513>)
  * Contributors: Jacob Perron, William Woodall

 -- Jacob Perron <jacob@openrobotics.org>  Wed, 23 Oct 2019 05:00:00 -0000

ros-eloquent-rcl-action (0.8.1-1bionic) bionic; urgency=high



 -- Jacob Perron <jacob@openrobotics.org>  Tue, 08 Oct 2019 05:00:00 -0000

ros-eloquent-rcl-action (0.8.0-1bionic) bionic; urgency=high

  * Fix rcl_action test_graph (#504 <https://github.com/ros2/rcl/issues/504>)
  * remove unused CMake code (#475 <https://github.com/ros2/rcl/issues/475>)
  * Contributors: Mikael Arguedas, ivanpauno

 -- Jacob Perron <jacob@openrobotics.org>  Thu, 26 Sep 2019 05:00:00 -0000

ros-eloquent-rcl-action (0.7.4-1bionic) bionic; urgency=high

  * rcl_action - user friendly error messages for invalid transitions (#448 <https://github.com/ros2/rcl/issues/448>)
  * Contributors: Siddharth Kucheria

 -- Jacob Perron <jacob@openrobotics.org>  Wed, 29 May 2019 05:00:00 -0000

ros-eloquent-rcl-action (0.7.3-1bionic) bionic; urgency=high

  * Fixed memory leaks in ``rcl_action`` unit tests (#442 <https://github.com/ros2/rcl/issues/442>)
  * Contributors: Prajakta Gokhale

 -- Jacob Perron <jacob@openrobotics.org>  Mon, 20 May 2019 05:00:00 -0000

ros-eloquent-rcl-action (0.7.2-1bionic) bionic; urgency=high

  * Update graph test for change to rmw names and types struct (#407 <https://github.com/ros2/rcl/issues/407>)
  * New interfaces and their implementations for QoS features (#408 <https://github.com/ros2/rcl/issues/408>)
  * Add return code to CancelGoal service response (#422 <https://github.com/ros2/rcl/issues/422>)
  * Rmw preallocate (#428 <https://github.com/ros2/rcl/issues/428>)
  * Contributors: Jacob Perron, M. M, Michael Carroll

 -- Jacob Perron <jacob@openrobotics.org>  Wed, 08 May 2019 05:00:00 -0000

ros-eloquent-rcl-action (0.7.1-1bionic) bionic; urgency=high

  * Renamed action state transitions (#409 <https://github.com/ros2/rcl/issues/409>)
  * Updated initialization of rmw_qos_profile_t struct instances. (#416 <https://github.com/ros2/rcl/issues/416>)
  * Contributors: Jacob Perron, M. M

 -- Jacob Perron <jacob@openrobotics.org>  Mon, 29 Apr 2019 05:00:00 -0000

ros-eloquent-rcl-action (0.7.0-1bionic) bionic; urgency=high

  * Added Action graph API (#411 <https://github.com/ros2/rcl/issues/411>)
  * Updated to use ament_target_dependencies where possible. (#400 <https://github.com/ros2/rcl/issues/400>)
  * Fixed typo in Doxyfile. (#398 <https://github.com/ros2/rcl/issues/398>)
  * Updated tests to use separated action types. (#340 <https://github.com/ros2/rcl/issues/340>)
  * Fixed minor documentation issues. (#397 <https://github.com/ros2/rcl/issues/397>)
  * Set symbol visibility to hidden for rcl. (#391 <https://github.com/ros2/rcl/issues/391>)
  * Fixed rcl_action documentation. (#380 <https://github.com/ros2/rcl/issues/380>)
  * Removed now unused test executable . (#382 <https://github.com/ros2/rcl/issues/382>)
  * Removed unused action server option 'clock_type'. (#382 <https://github.com/ros2/rcl/issues/382>)
  * Set error message when there is an invalid goal transition. (#382 <https://github.com/ros2/rcl/issues/382>)
  * Updated to pass context to wait set, and fini rmw context (#373 <https://github.com/ros2/rcl/issues/373>)
  * Contributors: Dirk Thomas, Jacob Perron, Sachin Suresh Bhat, William Woodall, ivanpauno

 -- Jacob Perron <jacob@openrobotics.org>  Sun, 14 Apr 2019 05:00:00 -0000

ros-eloquent-rcl-action (0.6.4-1bionic) bionic; urgency=high

  * Added parentheses around use of zerouuid macro (#371 <https://github.com/ros2/rcl/issues/371>)
  * Fixed logic that moves goal handles when one expires (#360 <https://github.com/ros2/rcl/issues/360>)
  * Updated to avoid timer period being set to 0 (#359 <https://github.com/ros2/rcl/issues/359>)
  * Contributors: Jacob Perron, Shane Loretz

 -- Jacob Perron <jacob@openrobotics.org>  Fri, 11 Jan 2019 06:00:00 -0000

ros-eloquent-rcl-action (0.6.3-1bionic) bionic; urgency=high



 -- Jacob Perron <jacob@openrobotics.org>  Thu, 13 Dec 2018 06:00:00 -0000

ros-eloquent-rcl-action (0.6.2-1bionic) bionic; urgency=high

  * [rcl_action] Bugfix: arithmetic error
  * Contributors: Jacob Perron

 -- Jacob Perron <jacob@openrobotics.org>  Thu, 13 Dec 2018 06:00:00 -0000

ros-eloquent-rcl-action (0.6.1-1bionic) bionic; urgency=high

  * Added wait_for_action_server() for action clients (#349 <https://github.com/ros2/rcl/issues/349>)
  * Updated to adapt to action implicit changes (#353 <https://github.com/ros2/rcl/issues/353>)
  * Added action interaction tests (#352 <https://github.com/ros2/rcl/issues/352>)
  * Enabled test_action_communication to compile against available rmw. (#351 <https://github.com/ros2/rcl/issues/351>)
  * Changed UUID type in action msgs (#338 <https://github.com/ros2/rcl/issues/338>)
  * Added rcl_action_server_is_valid_except_context (#348 <https://github.com/ros2/rcl/issues/348>)
  * Updated to fini even if node context is invalid and reset error (#346 <https://github.com/ros2/rcl/issues/346>)
  * Added timer to action server to check expired goals + asan fixes (#343 <https://github.com/ros2/rcl/issues/343>)
  * Increased timeout for rcl_wait in action tests (#344 <https://github.com/ros2/rcl/issues/344>)
  * Refactored init to not be global (#336 <https://github.com/ros2/rcl/issues/336>)


=== debian/control ===
Source: ros-eloquent-rcl-action
Section: misc
Priority: optional
Maintainer: Jacob Perron <jacob@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-eloquent-action-msgs, ros-eloquent-ament-cmake-gtest, ros-eloquent-ament-cmake-ros, ros-eloquent-ament-lint-auto, ros-eloquent-ament-lint-common, ros-eloquent-osrf-testing-tools-cpp, ros-eloquent-rcl, ros-eloquent-rcutils, ros-eloquent-rmw, ros-eloquent-rmw-implementation-cmake, ros-eloquent-rosidl-generator-c, ros-eloquent-test-msgs, ros-eloquent-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-eloquent-rcl-action
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-eloquent-action-msgs, ros-eloquent-rcl, ros-eloquent-rcutils, ros-eloquent-rmw, ros-eloquent-rosidl-generator-c, ros-eloquent-ros-workspace
Description: Package containing a C-based ROS action implementation

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/eloquent/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/eloquent" \
		-DAMENT_PREFIX_PATH="/opt/ros/eloquent" \
		-DCMAKE_PREFIX_PATH="/opt/ros/eloquent"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-eloquent-rcl-action//opt/ros/eloquent/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_install
